#!/bin/bash
params=/opt/cfengine/dc-scripts/params.sh

source "$(dirname ${0})/common.sh"
die() { error_exit $(basename ${0}) "${1}"; }

source "${params}" || die "Unable to source PARAMS file '${params}'"

# pre fetch function for VCS type GIT
git_postupdate() {
  echo "Calling git post-update"
  type "git" > /dev/null || die "git not found on path: $PATH"

  cd "${ROOT}" && (
      git push origin "${GIT_WORKING_BRANCH}:${GIT_BRANCH}"
  )
}

case "${VCS_TYPE}" in
    GIT) git_postupdate ;;
    *) die "Unsupported VCS_TYPE: '${VCS_TYPE}'" ;;
esac

