<?php

/**
 * Class CfSettings
 * Is used for work with cf_settings
 */
class CfSettings
{
    /** @var CfSettings */
    private static $instance = null;

    /** @var PDO $connection */
    private $connection;

    /**
     * CfSettings constructor.
     */
    private function __construct()
    {
        $this->connection = new PDO(
            "pgsql:host=" . OAUTH_DATABASE_HOST . "; dbname=" . OAUTH_DATABASE_NAME . ";port=" . OAUTH_DATABASE_PORT,
            OAUTH_DATABASE_USER,
            OAUTH_DATABASE_PASS
        );
    }

    /**
     * @return self
     */
    public static function getInstance()
    {
        if (!self::$instance) {
            self::$instance = new CfSettings();
        }

        return self::$instance;
    }

    /**
     * @param $key
     * @return array
     */
    public function getSetting($key)
    {
        $sql = "SELECT * FROM settings WHERE settings.key = {$this->connection->quote($key)} LIMIT 1";
        $result = $this->connection->query($sql)->fetchAll(PDO::FETCH_KEY_PAIR);
        
        return $result ? $result[$key] : null;
    }

    /**
     * @return PDO
     */
    public function getConnection(){
        return $this->connection;
    }
}