<?php

class CfUsers
{
    /**
     * @var PDO
     */
    private $dbConnection;

    /**
     * @var array
     */
    private $user = false;

    /**
     * @var string
     */
    private $adminRole = 'admin';

    /**
     * @var string
     */
    private $username = false;
    private $email = false;
    private $roles = [];



    public function __construct($username, $email = '', $roles = [])
    {
        $this->dbConnection = CfPdo::getInstance()->getConnection();
        $this->username = $username;
        $this->email = $email;
        $this->roles = $roles;
        $this->user = $this->getUser();
    }

    /**
     * @return bool
     */
    public function checkUserExistingAndCreateIfNot()
    {
        if (!$this->user) {
            $this->createUser();
        }

        return (boolean)$this->user;
    }


    /**
     * @return mixed
     */
    public function getUser()
    {
        return $this->dbConnection->query(sprintf('SELECT * FROM users WHERE username ILIKE \'%s\'',
            $this->username))->fetch(PDO::FETCH_ASSOC);
    }

    /**
     * @return bool
     */
    public function createUser()
    {
        return $this->dbConnection->query(sprintf('INSERT INTO "users" ("username", "name", "email", "external", "active", "roles", "changetimestamp")
                                                   VALUES (\'%s\', \'%s\', \'%s\', \'1\', \'0\', \'%s\', \'now()\');',
            $this->username, $this->username, $this->email, '{' . implode(',', $this->roles) . '}'))->execute();
    }

    /**
     * @return mixed
     */
    public function getUserRoles()
    {
        return $this->user != false && array_key_exists('roles', $this->user) ?
            explode(',', str_replace(['{', '}'], '', $this->user['roles'])) :
            false;
    }

    /**
     * @return bool
     */
    public function isAdminRole()
    {
        return (boolean)in_array($this->adminRole, $this->getUserRoles());
    }

    /**
     * @return mixed
     */
    public function getEmail()
    {
        return $this->user != false && in_array('email', $this->user) ? $this->user['email'] : false;
    }

    /**
     * @return mixed
     */
    public function getUserName()
    {
        return $this->username ;
    }

    /**
     * @return mixed
     */
    public function getActive()
    {
        return $this->user != false && in_array('active', $this->user) ? $this->user['active'] : false;
    }

    public function isExternal()
    {
        return $this->user != false && in_array('external', $this->user) ? $this->user['external'] : false;
    }

}