<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/**
 * Carabiner 1.45 configuration file.
 * CodeIgniter-library for Asset Management
 */
/*
  |--------------------------------------------------------------------------
  | Script Directory
  |--------------------------------------------------------------------------
  |
  | Path to the script directory.  Relative to the CI front controller.
  |
 */

$config['script_dir'] = 'scripts/';


/*
  |--------------------------------------------------------------------------
  | Style Directory
  |--------------------------------------------------------------------------
  |
  | Path to the style directory.  Relative to the CI front controller
  |
 */
if (is_constellation())
{
    $config['style_dir'] = 'themes/constellation/css/';
}
else
{
    $config['style_dir'] = 'themes/default/css/';
}


/*
  |--------------------------------------------------------------------------
  | Cache Directory
  |--------------------------------------------------------------------------
  |
  | Path to the cache directory. Must be writable. Relative to the CI
  | front controller.
  |
 */

$config['cache_dir'] = 'tmp/';




/*
 * The following config values are not required.  See Libraries/Carabiner.php
 * for more information.
 */



/*
  |--------------------------------------------------------------------------
  | Base URI
  |--------------------------------------------------------------------------
  |
  |  Base uri of the site, like http://www.example.com/ Defaults to the CI
  |  config value for base_url.
  |
 */

//$config['base_uri'] = 'http://www.example.com/';


/*
  |--------------------------------------------------------------------------
  | Development Flag
  |--------------------------------------------------------------------------
  |
  |  Flags whether your in a development environment or not. Defaults to FALSE.
  |
 */

$config['dev'] = (ENVIRONMENT == 'development') ? true : false; // set in index.php


/*
  |--------------------------------------------------------------------------
  | Combine
  |--------------------------------------------------------------------------
  |
  | Flags whether files should be combined. Defaults to TRUE.
  |
 */

$config['combine'] = TRUE;


/*
  |--------------------------------------------------------------------------
  | Minify Javascript
  |--------------------------------------------------------------------------
  |
  | Global flag for whether JS should be minified. Defaults to TRUE.
  |
 */

$config['minify_js'] = TRUE;


/*
  |--------------------------------------------------------------------------
  | Minify CSS
  |--------------------------------------------------------------------------
  |
  | Global flag for whether CSS should be minified. Defaults to TRUE.
  |
 */

$config['minify_css'] = TRUE;

/*
  |--------------------------------------------------------------------------
  | Force cURL
  |--------------------------------------------------------------------------
  |
  | Global flag for whether to force the use of cURL instead of file_get_contents()
  | Defaults to FALSE.
  |
 */

$config['force_curl'] = FALSE;


/*
  |--------------------------------------------------------------------------
  | Predifined Asset Groups
  |--------------------------------------------------------------------------
  |
  | Any groups defined here will automatically be included.  Of course, they
  | won't be displayed unless you explicity display them ( like this: $this->carabiner->display('jquery') )
  | See docs for more.
  |
  | Currently created groups:
  |	> jQuery (latest in 1.xx version)
  |	> jQuery UI (latest in 1.xx version)
  |	> Ext Core (latest in 3.xx version)
  |	> Chrome Frame (latest in 1.xx version)
  |	> Prototype (latest in 1.x.x.x version)
  |	> script.aculo.us (latest in 1.x.x version)
  |	> Mootools (1.xx version)
  |	> Dojo (latest in 1.xx version)
  |	> SWFObject (latest in 2.xx version)
  |	> YUI (latest core JS/CSS in 2.x.x version)
  |
 */

// CFEngine base
$config['groups']['CFEngine'] = array(
    'css' => array(
        array('../jqueryUI-bootstrap-theme/jquery-ui-1.8.16.custom.css', 'screen'),
        array('../bootstrap/compiled/css/cfengine.less.css', 'screen'),
        array('finders.css', 'screen'),
        // add cfengine MP custom styles
        array('bootstrap-wizard.css', 'screen')
    ),
    'js' => array(
        array('jquery-1.7.1.min.js', 'jquery-1.7.1.min.js', TRUE, FALSE),
        array('jquery-ui-1.8.18.custom.min.js', 'jquery-ui-1.8.18.custom.min.js', TRUE, FALSE),
        array('jquery.cookie.js', 'jquery.cookie.js', TRUE, FALSE),
        array('../themes/default/bootstrap/compiled/js/bootstrap.min.js', '../themes/default/bootstrap/compiled/js/bootstrap.min.js', TRUE, FALSE),
        array('dateformat.js', 'dateformat.js', TRUE, FALSE),
        array('common.js', 'common.js', TRUE, FALSE),
        array('detect_timezone.js', 'detect_timezone.js', TRUE, FALSE),
        array('modernizr.js', 'modernizr.js', TRUE, FALSE),
        array('../themes/default/bootstrap/cfengine/js/cfe-form-elements.js', '../themes/default/bootstrap/cfengine/js/cfe-form-elements.js', TRUE, FALSE),
        array('bootbox.js', 'bootbox.js', TRUE, FALSE),
        array('bootstrap.file-input.js', 'bootstrap.file-input.js', TRUE, FALSE),
        array('number-polyfill.js','number-polyfill.js',TRUE,FALSE),
        array('bootstrap-wizard.js', 'bootstrap-wizard.js', TRUE, FALSE),
        array('cfe-license-reminder.js', 'cfe-license-reminder', TRUE, FALSE),
        array('global-host-search-box.js', 'global-host-search-box.js', TRUE, FALSE),
    )
);

$config['groups']['iefix'] = array(
  'js' => array(
    array('html5shiv.js','html5shiv.js',TRUE,FALSE),
    array('json2.js','json2.js',TRUE,FALSE)
  )
);

$config['groups']['footer'] = array(
    'js' => array(
	    array('error-logger.js'),
        array('CFE_context_help.js', 'CF_context_help.js', TRUE, TRUE),
        array('useractivity/session_expired_modal.js', 'useractivity/session_expired_modal.js', TRUE, TRUE),
        array('CFE_footer_initialize.js', 'CFE_footer_initialize.js', TRUE, TRUE),
        array('CFE_high_availability_header.js', 'CFE_high_availability_header.js', TRUE, TRUE),
        array('CFE_license_header.js', 'CFE_license_header.js', TRUE, TRUE),
    )
);

