<?php

require_once APPPATH . '/libraries/Cf_REST_Controller.php';

/*
License information controller
*/
class Licenses extends Cf_REST_Controller
{
  function __construct()
  {
    parent::__construct();
    $this->load->model('license_model');
    $this->username = $this->session->userdata('username');
    $this->load->library('Setting_lib');
    $this->license_model->setRestClient($this->ion_auth->getRestClient());
  }

  /*
  * Return info about licenses
  * 
  */
  function status_get()
  {
    $data = array();

    try
    {
        $licenseDetails = $this->license_model->getLicenseDetails();
        $data = array(
        'details'     => $licenseDetails,
        'licenseGranted' => isset($licenseDetails['granted'])      ? $licenseDetails['granted']      : '',

        'licenseOwner'   => isset($licenseDetails['owner'])        ? $licenseDetails['owner']        : '',
        'licenseType'    => isset($licenseDetails['licenseType'])  ? $licenseDetails['licenseType']  : '',
        'expiry'         => isset($licenseDetails['expires'])       ? $licenseDetails['expires']       : ''
        );
        $this->respond_ok(json_encode($data));
    }
    catch (Exception $e)
    {
        log_message('license error:' . $e->getMessage());
    }
  }
}