<?php
class Dashboard extends Cf_Controller
{

    function __construct()
    {
        parent::__construct();
        setCurrentApplication('dashboard');
    }

    function index()
    {

        $requiredjs = array(
            array('libs/underscorejs/underscore.js'),

            array('libs/angularjs/angular.1.2.0.min.js'),
            array('libs/angularjs/angular-route.min.js'),
            array('libs/angularjs/angular-cookies.js'),
            array('libs/angularjs/angular-animate.1.2.0.min.js'),

            // services
            array('libs/angularjs-ui/angular-ui.min.js'),
            array('libs/angularjs-ui/ui-bootstrap-tpls-0.9.0.min.js'),

            array('libs/angularjs-ui/sortable.js'),

            array('chosen.jquery.min.js'),
            array('angular-chosen.js'),


            array('libs/class.js'),
            array('libs/namespace.js'),
            array('libs/baseclasses/BaseController.js'),

            array('libs/bootstrap-daterangepicker/moment.js'),
            array('notify.min.js'),
            // charts
            array('libs/highcharts/highcharts-ng.min.js'),

            array('dashboard/dca.js'),

            array('dashboard/app.js'),

            array('dashboard/controllers/dashboardController.js'),
            array('dashboard/controllers/alertsController.js'),
            array('dashboard/controllers/eventsController.js'),

            array('dashboard/directives/directives.js'),
            array('dashboard/directives/widgets.js'),
            array('dashboard/directives/hostCountWidget.js'),
            array('dashboard/directives/decommissionedHostsWidget.js'),
            array('dashboard/directives/inventoryWidget.js'),

            array('dashboard/services/autocompleteService.js'),
            array('dashboard/services/alertsService.js'),
            array('dashboard/services/rulesService.js'),
            array('dashboard/services/widgetwizardService.js'),
            array('dashboard/services/dashboardService.js'),
            array('dashboard/services/changesService.js'),
            array('dashboard/services/hostCountService.js'),
            array('dashboard/services/decommissionedHostsService.js'),
            array('dashboard/services/notificationService.js'),
            array('dashboard/services/eventsLogService.js'),
            array('dashboard/services/modalWindowService.js'),
            array('dashboard/services/widgetService.js'),
            array('dashboard/services/welcomeWizardService.js'),

            array('dashboard/helpers/widgetHelper.js'),
            array('dashboard/helpers/tourGuideHelper.js'),
            array('dashboard/helpers/changesWidgetHelper.js'),
            array('dashboard/helpers/hostCountWidgetHelper.js'),
            array('dashboard/helpers/decommissionedHostsWidgetHelper.js'),
            array('dashboard/helpers/inventoryWidgetHelper.js'),
            array('dashboard/helpers/dashboardHelper.js'),
            array('dashboard/helpers/commonHelper.js'),

            array('dashboard/filters/dashFilters.js'),

            // environment selector
            array('common_directives/environment/services/environmentService.js'),
            array('common_directives/environment/services/naviTreeService.js'),
            array('common_directives/environment/directives/environment_directive.js'),
            array('common_directives/environment/directives/environmentSelectionDirective.js'),

            // environment selector
            array('common_directives/environment/services/environmentService.js'),
            array('common_directives/environment/services/naviTreeService.js'),
            array('common_directives/environment/directives/environment_directive.js'),
            array('common_directives/environment/directives/environmentSelectionDirective.js'),

            // hosts include exclude selector
            array('common_directives/hostsInclude/services/paginationService.js'),
            array('common_directives/hostsInclude/services/includeExcludeService.js'),
            array('common_directives/hostsInclude/services/naviTreeService.js'),
            array('common_directives/hostsInclude/directives/include_exclude_directive.js'),
            array('common_directives/hostsInclude/directives/includeExcludeSelectionDirective.js'),

            // additional fields for inventory. Application specific!
            array('dashboard/invenory_data_addons.js'),

            // inventory filter for inventory alerts
            array('common_directives/inventory/inventory_dca.js'),
            array('common_directives/inventory/services/inventoryService.js'),
            array('common_directives/inventory/services/inventoryDataService.js'),
            array('common_directives/inventory/services/inventoryFilterService.js'),
            array('common_directives/inventory/helpers/inventoryHelper.js'),
            array('common_directives/inventory/directives/inventoryFilterDirectiveCtrl.js'),
            array('common_directives/inventory/directives/inventoryFilter_directive.js'),

            // daterange picker
            array('libs/bootstrap-daterangepicker/moment.js'),
            array('libs/bootstrap-daterangepicker/daterangepicker.js'),
            array('libs/bootstrap-daterangepicker/angular-daterangepicker.js'),
        );


        $highchartsjs = array(
            array('libs/highcharts/highcharts.js'),
            array('libs/highcharts/highcharts-more.js'),
            array('libs/highcharts/modules/no-data-to-display.js'), //module for android support
            array('libs/highcharts/modules/drilldown.js'),
            array('libs/highcharts/modules/exporting.js'),
            array('libs/highcharts/modules/rounded-corners.js'),
            array('libs/highcharts/modules/value-in-legend.js')
        );

        $requiredCss = array(
            array('chosen.min.css'),
            array('chosen-spinner.css'),
            array('daterangepicker-bs2.css')
        );

        $this->carabiner->css($requiredCss);

        $this->carabiner->js($requiredjs, $requiredjs, TRUE, TRUE, 'footer');
        $this->carabiner->js($highchartsjs, $highchartsjs, TRUE, FALSE, 'footer');

        $data = array(
            'title' => $this->lang->line('mission_portal_title') . " - " . 'Dashboard'
        );


        $data['isAdmin'] = false;

        $user_role = $this->session->userdata('roles');
        if (empty($user_role))
        {
            $user_role = array();
        }
        if (in_array('admin',$user_role) === true)
        {
            $data['isAdmin'] = true;
        }

        $this->template->load('template', 'dashboard/index', $data);
    }


    /**
     * Load partials
     *
     * @param type $partial - name of the view
     */
    function partials($partial)
    {
        $data = ['isAdmin' => $this->ion_auth->is_admin()];
        $view = 'partials/' . $partial . '.php';
        $this->load->view($view, $data);
    }

  }