## Migration tools
This tool can be used typically on a running hub or possibly on a development machine. The paths involved will be different for each different environment.

#### 1. Go to "mission-portal"  folder where index.php is located.
On a development machine:
```bash
cd /path/to/mission-portal
```
On a hub:
```bash
cd /var/cfengine/httpd/htdocs
```

#### 2. Hosts generation
Depending on whether the php binary is in your PATH or not. On a hub you would likely need to
provide the complete path to the php binary such as ```/var/cfengine/httpd/php/bin/php```

```bash
php index.php data_generator/HostsGenerator generate --hostKey=SHA=aa11bb --hostCount=14 --withSoftware --withPromiseExecutions
```
```hostKey``` - must be string like SHA=aa11bb. Hosts will have hostKey like %hostKey% + %sequence%
```hostCount``` - count of hosts that will be generated
```failCount``` - count of hosts with FAIL status
```withSoftware``` - set 1 to generate software data
```withPromiseExecutions``` - set 1 to generate promise executions data
```withMonitoring``` - set 1 to generate monitoring data

#### 2. Hosts simulation
Depending on whether the php binary is in your PATH or not. On a hub you would likely need to
provide the complete path to the php binary such as ```/var/cfengine/httpd/php/bin/php```

```bash
php index.php data_generator/HostsGenerator simulate --hostKey=SHA=aa11bb --hostCount=14 --withSoftware --withPromiseExecutions --interval=30 --verbose
```
```hostKey``` - must be string like SHA=aa11bb. Hosts will have hostKey like %hostKey% + %sequence%
```hostCount``` - count of hosts that will be generated
```withSoftware``` - set 1 to generate software data
```withPromiseExecutions``` - set 1 to generate promise executions data
```interval``` (seconds) - interval between data updating
```failCount``` - count of hosts with FAIL status
```insertLogs``` - insert logs into logs tables (emp.: softwarelog, variableslog). These logs tables significantly bloat database size.
```verbose``` - show additional output information
