<div class="contentWrapper">

    <div ng-model="sketch" data-ng-show="sketchShow"  data-ng-switch on="sketchView.name">

         <div class="pageTitle">
            <h1>
                <span>Sketch configuration</span><span class="beta">beta</span>
            </h1>
         </div>
        <?php
            $this->load->view('/partials/beta.php');
        ?>
         <div class="constrainContent margin-bottom">
            <div class="margin-bottom-small">
                <h3 class="inline">{{sketch.metadata.name}}</h3>
                <span class="label label-warning" ng-show="sketch.activations.length">Active</span>
                <span class="label" ng-show="!sketch.activations.length">Inactive</span>
            </div>
            <p>{{sketch.metadata.description}}</p>
            <ul class="unstyled meta">
                <li>
                    <h5 class="inline">Supported Operating Systems:</h5>
                    <span ng-repeat="(k,v) in sketch.metadata.depends.os[0]">{{v}} <span ng-hide="$last">,</span> </span>
                </li>
                <li>
                    <h5 class="inline">Sketch Version:</h5>
                    <span>{{sketch.metadata.version}}</span>
                </li>
                <li>
                    <h5 class="inline">Supported CFEngine Version:</h5>
                   <span>{{sketch.metadata.depends.cfengine.version}}</span>
                </li>
                <li>
                    <h5 class="inline">Tags: </h5>
                    <span class="label tag" ng-repeat="tag in sketch.metadata.tags">
                        {{tag}}
                    </span>
                </li>
            </ul>
        </div>
        <div><?php $this->load->view('/partials/_notification'); ?></div>
        <!-- SECTION TO SHOW WHEN ACTIVATE SKETCH IS CLICKED -->
        <div class="sketchActivateWrapper" ng-model="sketch" ng-switch-when="activate">

            <form novalidate name="inputForm" class="activation-form form-vertical">
                <div ng-form="subForm" class="required control-group" ng-class="{error:subForm.CF_MP_INTERNAL_SKETCH_activationName.$dirty && (subForm.CF_MP_INTERNAL_SKETCH_activationName.$invalid || subForm.CF_MP_INTERNAL_SKETCH_activationName.$error.validateDescription)}">

                    <label class="control-label" name="{{CF_MP_INTERNAL_SKETCH_activationName}}">
                        <span>Descriptive name</span>
                    </label>

                    <div class="controls">
                        <input
                        type="text"
                        ng-readonly="$parent.editMode"
                        ng-model="$parent.formsInput['CF_MP_INTERNAL_SKETCH_activationName']"
                        name="CF_MP_INTERNAL_SKETCH_activationName" class="input"
                        required=""
                        ng-pattern="/^[a-zA-Z0-9 _-]*$/"
                        validate-description="" alist="sketch.activations" editid="editingActivationId">
                        <span class="help-block" ng-show="!subForm.CF_MP_INTERNAL_SKETCH_activationName.$dirty && (!subForm.CF_MP_INTERNAL_SKETCH_activationName.$invalid || !subForm.CF_MP_INTERNAL_SKETCH_activationName.$error.validateDescription)">Unique name for your activation so you can recognize it later.</span>
                        <span class="help-block" ng-show="subForm.CF_MP_INTERNAL_SKETCH_activationName.$error.validateDescription">
                            A sketch with that name already exists.
                        </span>
                        <span class="help-block" ng-show="subForm.CF_MP_INTERNAL_SKETCH_activationName.$error.pattern">Invalid character in name.</span>
                        <span class="help-block" ng-show="subForm.CF_MP_INTERNAL_SKETCH_activationName.$dirty && subForm.CF_MP_INTERNAL_SKETCH_activationName.$invalid && subForm.CF_MP_INTERNAL_SKETCH_activationName.$error.required">
                            You must name your sketch.
                        </span>
                    </div>
                </div>

                <div class="control-group" ng-show="entryPointLists.length > 1" class="padding-bottom border-bottom animate-show">

                    <div data-ng-repeat="e in entryPointLists" class="radio">
                      <label class="control-label">
                        <input type="radio" name="entryPointName" value="{{e.key}}" ng-model="entryPoint.value" ng-change="changeEntryPoint(entryPoint)">
                        <span ng-if="e.meta.name">{{e.meta.name}}</span><span ng-if="!e.meta.name">{{e.key}}</span>
                      </label>
                    </div>


                </div>


                <!-- SECTION FOR DIFFERENT INPUT CONTROLS -->
                <div ng:repeat="inputs in inputTypes" data-ng-switch on="inputs.type" class="form-entry">
                    <div data-ng-switch-when="string" ng-form="subForm" class="control-group" ng-class="{error:subForm.name.$dirty && subForm.name.$invalid,required:!hasDefaultValue(inputs)}">
                        <div ng-hide="inputs.choice">
                            <label class="control-label" name="{{inputs.name}}">
                                <span ng-show="inputs.description">{{inputs.description}}</span>
                                <span ng-hide="inputs.description">{{inputs.name}}</span>
                            </label>

                            <div class="controls">
                                <input
                                    id="{{inputs.name}}"
                                    type="text"
                                    ng-model="formsInput[inputs.name]"
                                    name="name" class="input"
                                    ng-required="!hasDefaultValue(inputs)"
                                    dcvalidation=""
                                    dcValidationKey="{{inputs.name}}"
                                    validationData="formInputs[inputs.name]"
                                    dcValidationType="{{inputs.validation}}"
                                >
                                <span class=help-block ng-show="inputs.example">e.g. {{inputs.example}}</span>
                                <span class="help-block error" ng-show="subForm.name.$error.dcValidation">
                                    Validation failed. {{dcServerValidationMessage[inputs.name]}}
                                </span>
                            </div>
                        </div>

                        <div ng-show="inputs.choice" class="control-group" ng-class="{required:!hasDefaultValue(inputs)}">
                            <label class="control-label" name="{{inputs.name}}">
                                <span ng-show="inputs.description">{{inputs.description}}</span>
                                <span ng-hide="inputs.description">{{inputs.name}}</span>
                            </label>

                            <div class="controls">
                                <select
                                chozen
                                ng-init = "formsInput[inputs.name] =  formsInput[inputs.name] || inputs.default"
                                ng-model="formsInput[inputs.name]"
                                ng-options="c for c in inputs.choice">
                                </select>
                            </div>
                        </div>

                    </div>

                    <div data-ng-switch-when="boolean" ng-form="subForm" class="control-group" ng-class="{error:subForm.name.$dirty && subForm.name.$invalid}">
                        <div class="checkbox">
                            <label class="control-label" name="{{inputs.name}}" for="{{inputs.name}}">

                                <input
                                    ng-init='formsInput[inputs.name] = formsInput[inputs.name] || 0'
                                    id="{{inputs.name}}"
                                    type="checkbox"
                                    ng-model="formsInput[inputs.name]"
                                    name="name"
                                    ng-true-value="1"
                                    ng-false-value="0"
                                >
                                <span ng-show="inputs.description">{{inputs.description}}</span>
                                <span ng-hide="inputs.description">{{inputs.name}}</span>
                            </label>
                        </div>
                        <span class=help-block ng-show="inputs.example">e.g. {{inputs.example}}</span>
                        <span class="help-block error" ng-show="subForm.name.$error.dcValidation">
                            Validation failed. {{dcServerValidationMessage[inputs.name]}}
                        </span>
                    </div>

                    <div data-ng-switch-when="list" ng-form="subForm" class="control-group"  ng-class="{error:subForm.name.$dirty && subForm.name.$invalid,required:!hasDefaultValue(inputs)}">
                        <label class="control-label" name="{{inputs.name}}">
                            <span ng-show="inputs.description">{{inputs.description}}</span>
                            <span ng-hide="inputs.description">{{inputs.name}}</span>
                        </label>
                        <div class="controls">
                            <input
                                id="{{inputs.name}}"
                                type="text"
                                ng-model="formsInput[inputs.name]"
                                name="name" class="input"
                                csv-list=""
                                ng-required="!hasDefaultValue(inputs)"
                                dcvalidation=""
                                dcValidationKey="{{inputs.name}}"
                                validationData="formInputs[inputs.name]"
                                dcValidationType="{{inputs.validation}}"
                            >
                            <span class="help-block" ng-show="!inputs.example">Single value or comma separated list of values, e.g. item1,item2,item3</span>
                            <span class="help-block" ng-show="inputs.example">e.g. {{inputs.example}}</span>
                            <span class="help-block error" ng-show="subForm.name.$error.dcValidation">
                                Validation failed. {{dcServerValidationMessage[inputs.name]}}
                            </span>
                        </div>
                    </div>

                    <div data-ng-switch-when="array" class="control-group" ng-class="{required:!hasDefaultValue(inputs)}">
                        <label class="control-label" name="{{inputs.name}}">
                                <span ng-show="inputs.description">{{inputs.description}}</span>
                                <span ng-hide="inputs.description">{{inputs.name}}</span>
                        </label>
                        <div data-array-input-type="" meta-data="inputs" source="formsInput[inputs.name]" ng-if="hasKeyValueValidation(inputs)"></div>
                        <div data-json-input-type="" meta-data="inputs" source="formsInput[inputs.name]" ng-if="!hasKeyValueValidation(inputs)"> </div>
                    </div>
                </div>
            </form>

            <div class="margin-bottom">
                <div data-environment env="environment" sketch="sketch" show-hosts="showHosts">
                </div>
            </div>
            <div class="row-fluid buttons">
                <div>
                    <p class="pull-right">
                        <button type="submit" class="btn btn-large" data-ng-click="goBack()">Cancel</button>
                        <button ng-disabled="inputForm.$invalid || !environment.name" role="button" class="btn btn-large btn-primary" data-ng-click="activate()">Activate</button>
                    </p>
                </div>
            </div>
        </div>

        <!-- DEPLOYED SKETCH -->
        <div ng-switch-when="deployed">
            <div class="constrainContent" id="currentActivations">
            <h3>Current activations</h3>
            <div ng-if="isActivationViewLoading"><span class="loadinggif"></span></div>
            <div ng-if="activationLoadingError" class="alert alert-error">Failed loading activations. {{activationLoadingError}}</div>
            <div ng-if="sketch.activations.length">




            <div accordion close-others="'1'">
                <!--
                    ng-repeat is run before the accordion-group directive and so there will be a
                    new accordion-group element for each "group" in "groups".
                    The ng-repeat directive creates a new scope and puts the current "group" on it.
                -->
                <!--
                    So now in each accordion-group we reference:
                      group.title in the heading attribute,
                      group.anyOldValue in the is-open attribute
                      and
                      group.content in the body of the accordion.
                -->
                <div accordion-group
                    ng-repeat="activationViewModel in sketch.activations"
                    is-open="activationViewModel.isOpen"
                    >
                    <div ng-init="activatedHostStatusFilter={}" ng-controller="activationDetailLoadController">
                        <accordion-heading>
                            <h3>
                                <a href="javascript:void(0)">
                                    <i ng-class="{false:'icon-chevron-right',true:'icon-chevron-down'}[activationViewModel.isOpen]"></i>
                                    <span class="upper-first">{{activationViewModel.identifier}}</span>
                                </a>
                                <span ng-show="(activationViewModel.details.hosts | filter:{status:'notkept'}).length" class="badge badge-important pull-right">
                                    {{(activationViewModel.details.hosts | filter:{status:'notkept'}).length}}
                                </span>
                                <span ng-show="(activationViewModel.details.hosts | filter:{status:'warning'}).length" class="badge badge-warning pull-right">
                                    {{(activationViewModel.details.hosts| filter:{status:'warning'}).length}}
                                </span>
                            </h3>
                        </accordion-heading>
                        <div class="sketch">
                            <div>
                                <h5>Configuration</h5>
                                <div ng-show="activationViewModel.bundle">Bundle:<span class="config_val">{{activationViewModel.bundle}}</span></div>

                                    <div ng-repeat="(key,val) in activationViewModel.details.params" ng-show="inputTypesHasKey(key,activationViewModel)">
                                        <span class="upper-first">{{inputTypeGetDescriptionOrName(key,activationViewModel)}}:</span>
                                        <span ng-switch on="getInputTypeForKey(key,activationViewModel)">
                                            <span class="config_val" ng-switch-when='list'>
                                            <span ng-repeat="lval in val">{{lval}}<span ng-hide="$last">,</span></span>
                                            </span>
                                            <span class="config_val" ng-switch-when='string'>{{val}}</span>
                                            <span class="config_val" ng-switch-when='boolean'>{{val}}</span>
                                            <div class="inline-block config_val arraylist" ng-switch-when="array">
                                                <ul class="unstyled">
                                                    <li ng-repeat="(ak,av) in val">{{ak}}:{{av}}</li>
                                                </ul>
                                            </div>
                                        </span>
                                    </div>

                                    <p>
                                       Environment:
                                        <span class="config_val" ng-repeat="(key,val) in activationViewModel.details.environments" ng-show="key=='activated'"><span ng-mouseleave="showClassExpression=0" ng-mouseover="showClassExpression=1" >{{activationViewModel.metadata.environmentLabel}} </span> <span ng-hide="activationViewModel.metadata.environmentLabel">({{val.include.join(').(')}}) </span><span ng-show="showClassExpression" class="muted">{{activationViewModel.details.environments.activated.include}}</span></span>
                                    </p>

                            </div>
                            <a ng-init="isHostListCollapsed=true" ng-click="isHostListCollapsed = !isHostListCollapsed" ng-show="activationViewModel.details.hosts.length" href="javascript:void(0)">
                               <span ng-show="isHostListCollapsed">Show all hosts in this activation</span> <span ng-show="!isHostListCollapsed">Hide</span> ({{activationViewModel.details.hosts.length}})
                            </a>
                            <span class="text-warning" ng-show="(activationViewModel.details.hosts| filter:{status:'warning'}).length">{{(activationViewModel.details.hosts| filter:{status:'warning'}).length}} in progress</span>
                            <span class="text-error" ng-show="(activationViewModel.details.hosts| filter:{status:'notkept'}).length">{{(activationViewModel.details.hosts| filter:{status:'notkept'}).length}} failed</span>
                            <div class="well-contain margin-top-small" collapse="isHostListCollapsed" >
                                <div class="well">
                                <a ng-show="(activationViewModel.details.hosts | filter:{status:'notkept'}).length" ng-click="activatedHostStatusFilter = {status:'notkept'}" href="javascript:void(0)"><span ng-hide="activatedHostStatusFilter.status">show only failed host</span></a>
                                <a ng-show="activatedHostStatusFilter.status" ng-click="activatedHostStatusFilter = {}" href="javascript:void(0)">show all</a>
                                <ul class="unstyled">
                                    <li ng-repeat="h in activationViewModel.details.hosts | filter:activatedHostStatusFilter" ng-class="{warning:'warning',kept:'success',notkept:'error'}[h.status]" class="host">
                                        <div ng-show="h.status=='notkept'"><a ng-click="showPromiseNotKeptLog(h.key,activationViewModel)">{{h.name}}</a> <span class="text-error">(failed)</span></div>
                                        <span ng-show="h.status != 'notkept'">{{h.name}}</span>
                                    </li>
                                </ul>
                                </div>
                            </div>
                            <div class="row-fluid">
                                <p class="pull-right">
                                    <button class="btn btn-large" role="button" ng-click="removeSketchActivation(activationViewModel.identifier,sketch.metadata.name)" data-toggle="modal">Remove</button>
                                    <button ng-click="editActivation(activationViewModel)" class="btn btn-primary btn-large" type="submit">Edit</button>
                                </p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            </div>
            <div ng-show="sketch.activations.length == 0 && !isActivationViewLoading && !activationLoadingError" >
                <p class="alert alert-info">No activations found.</p>
            </div>
        </div>

            <div class="buttons">
                    <p class="pull-right">
                        <button ng-click="showActivationView()" class="btn btn-large btn-primary">New activation</button>
                    </p>
            </div>

    </div>
  </div>

    <div data-ng-show="sketchNotFound" class="alert alert-error">Sketch Not found</div>




</div>
<!-- COMMIT DIALOG -->
 <script type="text/ng-template" id="commitModal.html">
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" ng-click="cancelCommit()" aria-hidden="true">&times;</button>
        <h1>Commit your changes</h1>
    </div>
    <div class="modal-body">
        <form name="commitForm">
            <label for="inputComment" class="control-label">Describe your change</label>
            <textarea rows="3" class="input-block-level" id="inputComment" data-ng-model="input.commitMessage" required=""></textarea>
            <span class="help-block">The comment will be part of the version control commit.</span>
            <div ng-show="action=='activate'">
                <div class="checkbox">
                    <label for="createAlert" class="control-label">
                        <input type="checkbox" id="createAlert" data-ng-model="input.createAlert">
                        <span>Create an alert for this activation</span>
                    </label>
                </div>
                <span class="help-block">The alert will be added to a widget for this sketch, and placed on your current dashboard.</span>
            </div>
        </form>
    </div>
    <div class="modal-footer">
        <button class="btn btn-large cancel" ng-click="cancelCommit()">Cancel</button>
        <button ng-disabled="commitForm.$invalid" class="btn btn-large btn-primary" ng-click="commitChanges()">Commit</button>
    </div>
</script>

 <script type="text/ng-template" id="promiseLogModal.html">
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" ng-click="closePromiseNotKeptDialog()" aria-hidden="true">&times;</button>
        <h1>Promises not kept</h1>
    </div>
    <div class="modal-body">

        <table class="table table-condensed table-striped table-bordered">
            <thead>
                <tr>
                    <th ng-repeat="header in promiseNotKeptLogModel.header">{{header.columnName}}</th>
                </tr>
            </thead>
            <tbody>
                <tr ng-repeat="row in promiseNotKeptLogModel.rows" style="max-width:250px; word-break: break-all;">
                    <td ng-repeat="val in row">
                        <span ng-show="promiseNotKeptLogModel.header[$index] != 'TimeStamp'">{{val}}</span>
                        <span ng-show="promiseNotKeptLogModel.header[$index] == 'TimeStamp'">{{val * 1000 | date:'yyyy-MM-dd HH:mm:ss Z'}}</span>
                    </td>
                </tr>
            </tbody>
        </table>

    </div>
    <div class="modal-footer">

        <button class="btn btn-large pull-left"  ng-show="!ALLOW_CF_RUNAGENT"  title="You are not in the cf_remoteagent role, and therefore not allowed to run remote agents. Please contact your Mission Portal administrator." ng-disabled="true"> <i style="color:red" class="icon icon-exclamation-sign"></i>
            Show verbose output
        </button>
        <a class="btn btn-large pull-left" target="_blank" href="<?php echo site_url('designcenter/dcapi/runagent'); ?>/{{promiseNotKeptLogModel.selectedHost.hostkey}}" role="button"  ng-show="ALLOW_CF_RUNAGENT"  title="Run cf-runagent to get verbose log">Show verbose output
        </a>

        <button class="btn btn-large" ng-click="closePromiseNotKeptDialog()">Close</button>

    </div>
</script>

<!-- Loading DIALOG -->
 <script type="text/ng-template" id="loadingModal.html">
    <div class="modal-header no-border">
    <a ng-show="processingAlert.length" ng-click="close()" class="close" href="javascript:void(0)">×</a>
    </div>
    <div class="modal-body loader">
        <p class="muted" ng-show="!processingAlert.length">
            <span class="loadinggif"></span>
            <p class="loadingMessage">{{loadingMessage}}</p>
            <p ng-show="!loadingMessage">Processing please wait... </p>
        </p>
        <alert ng-repeat="palert in processingAlert" type="palert.type">
            {{palert.msg}}
       </alert>
    </div>
    <div class="modal-footer" ng-show="processingAlert.length">
        <button class="btn btn-large btn-primary" ng-click="close()">Close</button>
    </div>
</script>
