<div class="settingsPage">
    <div class="left-column">
        <?php include('settingsSideBar.php'); ?></div>
    <div class="right-column">
        <div class="pageTitle">

            <h1>
                <span>Version control repository</span>
                  <?php /*hide if no settings */ if (!empty($hasSettings)) { ?><a href="<?php echo site_url('settings/designCenter_reset/'); ?>"  class="btn btn-large pull-right" id="clear-git-settings">Clear settings</a><?php } ?>
            </h1>

        </div>

        <div>

            <div class="pullTop">

                <?php
                if (($this->session->flashdata('message')) || (!empty($message) && is_array($message)))
                {
                    $flashMessage = $this->session->flashdata('message') ? $this->session->flashdata('message') : $message;
                    $content = $flashMessage['content'];
                    $content_class = $flashMessage['type'];
                    ?>

                <div class="alert <?php echo $content_class; ?>
                     ">
                    <button class="close" data-dismiss="alert">×</button>
                    <?php echo nl2br($content); ?>
                </div>
                <?php } ?>
            </div>


                    <?php
                    $attributes = array('class' =>
                        'form-horizontal',
                        'id' => 'VCSform',
                        'method' => 'POST',
                        'enctype' => "multipart/form-data"
                    );
                    echo form_open('settings/designCenter/', $attributes);
                    ?>
                    <div class="control-group required">
                        <label class="control-label" for="gitServer"> <b>Git server url</b> (ssh)
                        </label>
                        <div class="controls">
                            <textarea class="input-xlarge" id="gitServer" name="gitServer"  value=""><?php echo $gitServer; ?></textarea>
                            <p class="help-block"><?php echo tooltip('tooltip_git_url', '', true); ?></p>
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label" for="gitBranch"> <b>Git branch</b>
                        </label>
                        <div class="controls">
                            <input class="input-xlarge" type="text" id="gitBranch" name="gitBranch"  value="<?php echo $gitBranch; ?>" />
                        </div>
                    </div>

                    <div class="control-group required">
                        <label class="control-label" for="gitEmail"> <b>Committer email</b>
                        </label>
                        <div class="controls">
                            <input class="input-xlarge" id="gitEmail" type="email" name="gitEmail"  value="<?php echo $gitEmail; ?>" />
                        </div>
                    </div>

                    <div class="control-group required">
                        <label class="control-label" for="gitAuthor">
                            <b>Committer name</b>
                        </label>
                        <div class="controls">
                            <input id="gitAuthor" type="text" name="gitAuthor" class="input-xlarge" value="<?php echo $gitAuthor; ?>" />
                            <p class="help-block">The git committer name and email is set to the user name and email of the Mission Portal user that makes the commit</p>
                        </div>
                    </div>

                    <div class="control-group required">
                        <label class="control-label" for="gitPrivateKey">
                            <b>Git private key</b>
                        </label>
                        <div class="controls">
                            <input type="file" name="gitPrivateKey" title="Choose file" /><span class="file-input-name">No file chosen</span>
                        </div>
                    </div>

                    <div  id="btnholder" class="buttons margin-top">
                        <input id="update" type="hidden" name="update" value="1" />
                        <button type="submit" id="formSubmit" value="Submit" class="btn btn-large btn-primary pull-right">Apply</button>
                    </div>

                    <?php echo form_close(); ?>

        </div>
    </div>
</div>

<script type="text/javascript">

    $(document).ready(function() {


         $('#clear-git-settings').click(
            function(e) {
                e.preventDefault();
                var href = $(this).attr("href");
                bootbox.dialog("<p>Are you sure you want to clear the settings?</p>", [{

                "label" : "Cancel",
                "class" : "btn btn-large",
                "callback": function() {

                    }
                }, {
                    "label" : "Ok",
                    "class" : "btn btn-large btn-primary",
                    "callback": function() {
                        window.location.href = href;
                    }
                }],{
                    header:"<h2>Clear settings?</h2>",
                    'onEscape': function(){}
                });

            }

        );

        $('#VCSform').submit(
            function(e) {
                e.preventDefault();
                var currentForm = this;
                bootbox.dialog("<div class='alert alert-warning'><p>WARNING: Changing your upstream version control repository or branch will reset all your sketch activations and masterfiles contents as a whole to what's in the new repository and branch.</p><p>If the 'cfengine_internal_masterfiles_update' class is defined in the currently deployed update policy this will happen automatically. To manually complete this operation run '/var/cfengine/bin/cf-agent --no-lock --define cfengine_internal_masterfiles_update --file /var/cfengine/share/NovaBase/masterfiles/update.cf'.</p><p>Are you REALLY sure you want to do this?</p></div>", [{

                    "label" : "Cancel",
                    "class" : "btn btn-large",
                    "callback" : function(){}
                }, {
                    "label" : "Confirm",
                    "class" : "btn btn-large btn-primary",
                    "callback":  function() {
                        common.globalSpinner.show();
                        currentForm.submit();
                    }
                }], {
                    header:"<h2>Change settings?</h2>",
                    'onEscape': function(){}
                });
            }
        );

        $('input[type=file]').bootstrapFileInput();
        $('.file-input-wrapper').addClass('btn-large');

    });

</script>
