<?php

namespace Controllers;

use Interop\Container\ContainerInterface;

/**
 * Class ProtectedController
 * @package Controllers
 */
class ProtectedController extends BaseController
{
    /**
     * ProtectedController constructor.
     * @param ContainerInterface $container
     */
    public function __construct(ContainerInterface $container)
    {
        parent::__construct($container);

        if (!$this->checkToken()) {
            throw new \Exception('Permission deny.');
        };
    }

    /**
     * @return bool
     */
    private function checkToken()
    {
        $authorizationToken = $this->container->get('request')->getHeaderLine('Authorization');
        return $this->container->get('accessToken') == $authorizationToken;
    }
}