<?php

namespace Services\Ldap;


/**
 * Class BaseAuth
 * @package Ldap\Auth
 */
abstract class BaseLdap
{

    /**
     * @var array
     */
    protected $config;

    /**
     * @var mixed
     */
    protected $provider;


    /**
     * BaseAuth constructor.
     * @param array $config
     * @param mixed $provider
     */
    public function __construct($config = [], $provider = false)
    {
        $this->config = $config;
        $this->provider = $provider;
    }

    /**
     * @return mixed
     */
    public function isProvider()
    {
        return $this->provider;
    }

    /**
     * @param mixed $provider
     */
    public function setProvider($provider)
    {
        $this->provider = $provider;
    }

    /**
     * @param $config
     */
    public function setConfig($config)
    {
        $this->config = $config;
    }

    /**
     * @return array
     */
    public function getConfig()
    {
        return $this->config;
    }


    /**
     * @param $username
     * @param $password
     * @return mixed
     */
    public abstract function bind($username, $password);

}