var tourGuide = new Tour({
    backdrop: true,
    backdropPadding: 5,
    onEnd: function () {
        window.location.href = '/index.php/dashboard';
    },
    template: '<div class="popover" role="tooltip"> ' +
        '<div class="arrow"></div> ' +
        '<h3 class="popover-title"></h3> ' +
        '<div class="popover-content"></div> ' +
        '<div class="popover-navigation"> <div class="btn-group  pull-left"> ' +
        '<button class="btn btn-sm btn-default" data-role="prev"><i class="icon-arrow-left"></i> Prev</button> ' +
        '<button class="btn btn-sm btn-default" data-role="next">Next <i class="icon-arrow-right"></i></button></div>' +
        '<div class="btn-group  pull-right"> ' +
        '<button class="btn btn-sm pause-button" data-role="pause-tour"><i class="icon-pause"></i> Pause</button> ' +
        '<button class="btn btn-sm  end-button" data-role="end"><i class="icon-stop"></i> End tour</button> </div>  </div> ',
    steps: [
        {
            element: "div[ng-controller=\"dataTransferController\"]",
            title: "Export / Import",
            content: "We have added new possibilities to transfer Mission portal data between hubs",
            placement: "bottom",
            path: "/index.php/data_transfer",
            onShow: function () {
                let def = $.Deferred();
                let interval = setInterval(function () {
                    if ($('#globalSpinner').css('display') == 'none') {
                        clearInterval(interval);
                        def.resolve();
                    }
                }, 500);
                return def.promise();
            },
        },
        {
            element: "button[ng-show=\"showDismissHostButton\"]",
            title: "Dismiss possibility",
            content: "We have added health diagnostics dismiss possibility to exclude specific hosts from health reporting",
            placement: "bottom",
            path: "/index.php/advancedreports#/health-diagnostic/hosts-never-collected",
            onShow: function () {
                let def = $.Deferred();
                let interval = setInterval(function () {
                    if ($('#globalSpinner').css('display') == 'none') {
                        clearInterval(interval);
                        def.resolve();
                    }
                }, 500);
                return def.promise();
            }
        },
        {
            element: "#dropdownHealth",
            title: "Health diagnostic API",
            content: "We have added new <a target='_blank' href='https://docs.cfengine.com/docs/3.12/reference-enterprise-api-ref-health-diagnostic.html'>Health diagnostic API</a>",
            placement: "bottom",
            path: "/index.php/advancedreports#/health-diagnostic/hosts-never-collected",
            onShow: function () {
                let def = $.Deferred();
                let interval = setInterval(function () {
                    if ($('#globalSpinner').css('display') == 'none') {
                        clearInterval(interval);
                        def.resolve();
                    }
                }, 500);
                return def.promise();
            }
        },
        {
            element: 'div[ng-switch-when="decommissionedHosts"]',
            title: "New decommissioned hosts count widget",
            content: "New decommissioned hosts count widget allows you to visualize the number of decommissioned agents over a specified range of time.",
            placement: "bottom",
            path: "/index.php/dashboard#index",
            onShow: function() {
                var def = $.Deferred();

                var interval = setInterval(function () {
                    if ($('div[ng-switch-when="decommissionedHosts"]').length > 0) {
                        clearInterval(interval);
                        def.resolve();
                    }
                }, 500);
                return def.promise();
            },
        },

    ]
});

if (window.localStorage.getItem('tourStarted') === 'true' && window.localStorage.getItem('tourPaused') !== 'true') {
    tourGuide.init().start();
}

var resumeButtonHtml = '<button class="btn btn-large resume-tour-guide"><i class="icon-play "></i> Resume tour guide</button>';

$('[data-role="pause-tour"]').live('click', function () {
    $('.tour-tour').css('visibility', 'hidden');
    $('.tour-backdrop').css('visibility', 'hidden');
    window.localStorage.setItem('tourPaused', 'true');

    $('body').append(resumeButtonHtml)
});

if (window.localStorage.getItem('tourPaused') === 'true') {
    $('body').append(resumeButtonHtml)
}

$('.resume-tour-guide').live('click', function () {
    window.localStorage.setItem('tourPaused', 'false');
    window.localStorage.removeItem('tour_redirect_to');
    tourGuide.init().start(true);
    $('.tour-tour').css('visibility', 'visible');
    $('.tour-backdrop').css('visibility', 'visible');
    $('.resume-tour-guide').remove();
});
