'use strict';
/*common functions */


angular.
    module('changesHelpers', []).
    factory('changesHelper', ['$q', 'changesService', 'notificationService',
                        function($q, changesService, notificationService) {
    var helper = {};

    var changesVariables = {};

    /**
     * Get changes variables from DB
     *
     * @returns {@exp;defered@pro;promise}
     */
    helper.getChangesVariables = function() {
        var self = this, deferred = $q.defer();

        changesService.getChangesFields().then(
            function(result) {
                changesVariables = result.data;
                changesVariables = true // COMMENT OUT
                deferred.resolve(changesVariables);
            },
            function(error) {
                error.data[0].text = error.data[0].text || 'Error encountered. Please view the logs for more detailed information.';
                notificationService.setNotification('error', error.data);
                deferred.reject(error);
            }
        );

        return deferred.promise;
    };

    return helper;

}]);

