'use strict';

var DC = angular.module('dc', ['ui', 'ngRoute', 'notifications', 'dc.sketchService', 'dc.dashboardService', 'dc.naviTreeService', 'dc.sketchModel', 'dc.directives','dc.filters','ui.bootstrap', 'ngCookies'],
        function($routeProvider, $locationProvider) {
            $routeProvider.when('/index', {
                templateUrl: MP_SITE_URL + '/designcenter/partials/index',
                controller: indexController
            });
            $routeProvider.when('/sketch/:sketchid', {
                templateUrl: MP_SITE_URL + '/designcenter/partials/sketch',
                controller: sketchController
            });
            $routeProvider.when('/sketch/:sketchid/:activationid', {
                templateUrl: MP_SITE_URL + '/designcenter/partials/sketch',
                controller: sketchController
            });
             $routeProvider.when('/config/:sketchid', {
                templateUrl: MP_SITE_URL + '/designcenter/partials/config',
                controller: sketchConfigController
            });
            $routeProvider.otherwise({redirectTo: '/index'});

            // configure html5 to get links working
            // If you don't do this, you URLs will be base.com/#/home rather than base.com/home
            //$locationProvider.html5Mode(true);
        }
);
DC.constant('DC_CONSTANTS', {
    version: 3.5
});

DC.config(['$httpProvider', function($httpProvider) {
        //This header was removed from recent version of angular.
        // PHP looks at this header to separate request between regular and AJAX.
        $httpProvider.defaults.headers.common["X-Requested-With"] = 'XMLHttpRequest';
        // IE fix to prevent caching
        $httpProvider.defaults.headers.common["If-Modified-Since"] = 0;
}]);
