var indexController = BaseController.extend({
    _sketchCategoryModel: null,
    _sketchCategory: null,
    /**
     * Initialize  Controller
     * @param $scope, current controller scope
     */
    init: function($scope, $timeout, $modal, $cookieStore, DC_CONSTANTS) {
        this._super($scope);
        this.$modal = $modal;
        this.$cookieStore = $cookieStore;
        this.$timeout = $timeout;
        $scope.version = DC_CONSTANTS.version;
        this._checkForCookie();
    },
    defineScope: function() {
        this.$scope.instance    = "indexController";
        this.$scope.openBeta   = this.openBeta.bind(this);
    },

    openBeta: function() {
        var self = this;

        if (self.$scope.modalOpen) return;

        self.$scope.modalInstance = self.$modal.open({
          templateUrl: 'betaModal.html',
          controller: function($scope, $modalInstance) {
            $scope.noShow = {
                checked:false
            };
            $scope.understood = function() {
                self.$cookieStore.put('noShow', $scope.noShow.checked);
                this.close();
            }

            $scope.close = function () {
                self.$scope.modalInstance.close();
                self.$scope.modalOpen = false;
            };
          }
        });

        self.$scope.modalOpen = true;
    },

    _checkForCookie: function() {
        var self = this;

        if (!self.$scope.noShow) {
            self.$scope.noShow = {'checked':false};
        } 

        self.$scope.cookieValue = self.$cookieStore.get('noShow');
        if (!self.$scope.cookieValue) {
           self.$timeout(function() {
                self.$scope.openBeta();
           },1500);   
        }
    }

});


indexController.$inject = ['$scope', '$timeout', '$modal', '$cookieStore', 'DC_CONSTANTS'];