$(function () {
    var hostSearchUrl = MP_SITE_URL + '/host/searchHost',
        hostPageUrl = MP_SITE_URL + '/assets/host_assets/',
        $globalHostSearchInput = $('#global-host-search-input');

    $globalHostSearchInput.autocomplete({
        minLength: 3,
        source: function (request, response) {
            $.ajax({
                type: 'get',
                url: hostSearchUrl,
                dataType: 'json',
                data: {query: request.term},
                cache: false,
                success: function (data) {
                    var patternForIP = /^[0-9.]+$/;
                    if (data.length > 0) {
                        var result = $.map(data, function (value, key) {
                            return {
                                label: patternForIP.test(request.term) ? value.ipaddress : value.hostname,
                                value: value.hostkey
                            }
                        });
                        response(result);
                    } else {
                        response([{
                            label: 'No results found.',
                            value: false
                        }]);
                    }
                }
            })
        },
        focus: function (event, ui) {
            event.preventDefault();
        },
        select: function (event, ui) {
            var hostKey = ui.item.value;
            event.preventDefault();
            if (hostKey !== false) {
                window.location.replace(hostPageUrl + hostKey);
            }
        }
    });
});